Attribute VB_Name = "dhMultiMonitor"
Option Explicit

Public Declare Function LoadLibraryEx Lib "kernel32.dll" Alias "LoadLibraryExA" _
    (ByVal lpFileName As String, ByVal hFile As Long, ByVal dwFlags As Long) As Long
Public Declare Function GetProcAddress Lib "kernel32.dll" _
    (ByVal hModule As Long, ByVal lpProcName As String) As Long
Public Declare Function GetModuleHandle Lib "kernel32.dll" Alias "GetModuleHandleA" _
    (ByVal lpModuleName As String) As Long
Public Declare Function FreeLibrary Lib "kernel32.dll" _
    (ByVal hLibModule As Long) As Boolean
Public Declare Function EnumDisplayMonitors Lib "user32.dll" _
    (ByVal hDC As Long, ByRef lprcClip As Any, ByVal lpfnEnum As Long, ByVal dwData As Long) As Boolean
Public Declare Function GetMonitorInfo Lib "user32.dll" Alias "GetMonitorInfoA" _
    (ByVal hMonitor As Long, ByRef lpmi As MONITORINFOEX) As Boolean
Public Declare Function MonitorFromPoint Lib "user32.dll" (ByVal x As Long, ByVal y As Long, ByVal dwFlags _
    As Long) As Long
    
Public Declare Function SetWindowPos Lib "user32.dll" (ByVal hWnd As Long, ByVal hWndInsertAfter As Long, _
    ByVal x As Long, ByVal y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long) As Long
Public Const HWND_BOTTOM = 1
Public Const HWND_NOTOPMOST = -2
Public Const HWND_TOP = 0
Public Const HWND_TOPMOST = -1

Public Const SWP_NOSIZE As Long = &H1
Public Const SWP_NOMOVE As Long = &H2
Public Const SWP_NOZORDER As Long = &H4
Public Const SWP_NOREDRAW As Long = &H8
Public Const SWP_NOACTIVATE As Long = &H10
Public Const SWP_FRAMECHANGED As Long = &H20
Public Const SWP_SHOWWINDOW As Long = &H40
Public Const SWP_HIDEWINDOW As Long = &H80
Public Const SWP_NOCOPYBITS As Long = &H100
Public Const SWP_NOOWNERZORDER As Long = &H200
Public Const SWP_NOSENDCHANGING As Long = &H400
Public Const SWP_DEFERERASE As Long = &H2000
Public Const SWP_ASYNCWINDOWPOS As Long = &H4000

Public Const CCHDEVICENAME = 32
Public Const MONITORINFOF_PRIMARY = &H1
Public Const MONITOR_DEFAULTTONEAREST = &H2
Public Const MONITOR_DEFAULTTONULL = &H0
Public Const MONITOR_DEFAULTTOPRIMARY = &H1

Public Declare Function GetActiveWindow Lib "user32.dll" () As Long

Public Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type

Public Type MONITORINFOEX
    cbSize As Long
    rcMonitor As RECT
    rcWork As RECT
    dwFlags As Long
    szDevice As String * CCHDEVICENAME
End Type

Private Declare Function GetDC Lib "user32.dll" (ByVal hWnd As Long) As Long
Private Declare Function ReleaseDC Lib "user32.dll" (ByVal hWnd As Long, _
    ByVal hDC As Long) As Long
Private Declare Function GetDeviceCaps Lib "gdi32" (ByVal hDC As Long, _
    ByVal nIndex As Long) As Long

Const LOGPIXELSX = 88
Const LOGPIXELSY = 90
Const TWIPSPERINCH = 1440
Const PointsPerInch = 72

Private Declare Function GetSystemMetrics Lib "user32.dll" (ByVal nIndex As Long) As Long

Private Const SM_CXFULLSCREEN = 16
Private Const SM_CYFULLSCREEN = 17
Private Const SM_CXSCREEN As Long = 0
Private Const SM_CYSCREEN As Long = 1

Public Enum SystemMetricsConstants
    smScreenWidth = SM_CXSCREEN
    smScreenHeight = SM_CYSCREEN
End Enum

Dim MonitorId() As String
Public MonitorArray() As String
Public MonitorNumber As Long

Public Sub setMonitorArray()
    Dim i As Integer
'    Debug.Print "Number of monitors in this system : " & GetMonitorId
    ReDim MonitorArray(GetMonitorId - 1)
    For i = 1 To UBound(MonitorId)
        MonitorArray(i - 1) = PrintMonitorInfo(MonitorId(i), False)
    Next i
End Sub

Public Function GetMonitorId()  'the number of screens only
    ReDim MonitorId(0)
    ' Of course dual screen systems are not available on all Win versions
    If FunctionExist("user32.dll", "EnumDisplayMonitors") = True Then
        If EnumDisplayMonitors(&H0, ByVal &H0, AddressOf MonitorEnumProc, &H0) = False Then
            Failed "EnumDisplayMonitors"
        End If
    End If
    GetMonitorId = UBound(MonitorId)
End Function

' Ermitteln der Monitorinfos
Private Function PrintMonitorInfo(ForMonitorID As String, deb As Boolean) As String
    Dim moniInf As String, moniPrim As String
    Dim MONITORINFOEX As MONITORINFOEX
    MONITORINFOEX.cbSize = Len(MONITORINFOEX)
    If GetMonitorInfo(CLng(ForMonitorID), MONITORINFOEX) = False Then Failed "GetMonitorInfo"
    With MONITORINFOEX
        If deb Then
            Debug.Print "Monitor info for device number : " & ForMonitorID
            Debug.Print "---------------------------------------------------"
            Debug.Print "Device Name : " & .szDevice
        End If
        If .dwFlags And MONITORINFOF_PRIMARY Then
            If deb Then Debug.Print "Primary Display = True"
            moniPrim = "True"
        Else
            If deb Then Debug.Print "Primary Display = False"
            moniPrim = "False"
        End If
        moniInf = ForMonitorID & ";" & Replace(.szDevice, vbNullChar, "") & ";" & moniPrim & ";"
        With .rcMonitor
            If deb Then
                Debug.Print "Monitor Left : " & .Left
                Debug.Print "Monitor Top : " & .Top
                Debug.Print "Monitor Right : " & .Right
                Debug.Print "Monitor Bottom : " & .Bottom
            End If
            moniInf = moniInf & "(" & .Left & "," & .Top & "," & .Right & "," & .Bottom & ");"
        End With
        With .rcWork
            If deb Then
                Debug.Print "Work area Left : " & .Left
                Debug.Print "Work area Top : " & .Top
                Debug.Print "Work area Right : " & .Right
                Debug.Print "Work area Bottom : " & .Bottom
            End If
            moniInf = moniInf & "(" & .Left & "," & .Top & "," & .Right & "," & .Bottom & ");"
        End With
    End With
    If deb Then
        Debug.Print
        Debug.Print
    End If
    PrintMonitorInfo = moniInf
End Function

' Ermitteln eines Screen Rechtecks
' scrNr: die Screen-Nummer
Public Function GetScreenParams(scrNr As Integer) As RECT
    Dim st As String, sp() As String
    Dim r As RECT
    sp = Split(MonitorArray(scrNr), ";")
    MonitorNumber = CLng(sp(0))
    st = sp(3)  'das Rechteck
    st = Replace(Replace(st, "(", ""), ")", "")
    sp = Split(st, ",")
    With r
        .Left = CInt(sp(0)): .Top = CInt(sp(1))
        .Right = CInt(sp(2)): .Bottom = CInt(sp(3))
    End With
    GetScreenParams = r
End Function

' Liegt Punkt im Screen
' scrNr: die Screen-Nummer
' px: X-Koordinate des Punkts
' py: Y-Koordinate des Punkts
Public Function GetPointInScreen(scrNr As Long, px As Long, py As Long) As Boolean
    Dim W As Boolean
    W = (MonitorFromPoint(px, py, MONITOR_DEFAULTTONEAREST) = MonitorNumber)
    If W Then
        Debug.Print "The point (" & CStr(px) & "," & CStr(py) & ") lies within the range of this monitor..."
    End If
    GetPointInScreen = W
End Function

' Liegt Punkt im Rechteck
' px: X-Koordinate des Punkts
' py: Y-Koordinate des Punkts
' rLeft, rTop, rRight, rBottom: die Parameter des Rechtecks
Public Function GetPointInRectangle(px As Long, py As Long, _
    rLeft As Long, rTop As Long, rRight As Long, rBottom As Long) As Boolean
    GetPointInRectangle = (px >= rLeft And px <= rRight And py >= rTop And py <= rBottom)
End Function

' Liegt Rechteck im Rechteck (rect2 in rect1)
' rect1: das Rechteck, in dem das andere liegen soll (Parameter als Array)
' rect2: das Rechteck, dessen Lage geprft werden soll (Parameter als Array)
Public Function GetRectInRectR(rect1() As Variant, rect2() As Variant) As Boolean
    Dim w1 As Boolean, w2 As Boolean
    w1 = GetPointInRectangle(CInt(rect2(0)), CInt(rect2(1)), _
                            CInt(rect1(0)), CInt(rect1(1)), CInt(rect1(2)), CInt(rect1(3)))
    w2 = GetPointInRectangle(CInt(rect2(2)), CInt(rect2(3)), _
                            CInt(rect1(0)), CInt(rect1(1)), CInt(rect1(2)), CInt(rect1(3)))
    GetRectInRectR = (w1 And w2)
End Function

Public Function FunctionExist(ByVal strModule As String, ByVal strFunction As String) As Boolean
    Dim hHandle As Long
    hHandle = GetModuleHandle(strModule)
    If hHandle = &H0 Then
        Failed "GetModuleHandle"
        hHandle = LoadLibraryEx(strModule, &H0, &H0): If hHandle = &H0 Then Failed "LoadLibrary"
        If GetProcAddress(hHandle, strFunction) = &H0 Then
            Failed "GetProcAddress"
        Else
            FunctionExist = True
        End If
        If FreeLibrary(hHandle) = False Then Failed "FreeLibrary"
    Else
        If GetProcAddress(hHandle, strFunction) = &H0 Then
            Failed "GetProcAddress"
        Else
            FunctionExist = True
        End If
    End If
End Function

Public Sub Failed(ByVal strFunction As String)
    If errMsg = True Then
        If Err.LastDllError = 0 Then
            MessageBoxEx &H0, strFunction & vbCrLf & vbCrLf & "Failed", _
                "Error", MB_OK Or MB_ICONWARNING Or MB_SETFOREGROUND, 0
        Else
            Errors Err.LastDllError, strFunction
        End If
    End If
End Sub

Public Function MonitorEnumProc(ByVal hMonitor As Long, ByVal hdcMonitor As Long, _
    ByRef lprcMonitor As RECT, ByVal dwData As Long, _
    Optional ByVal px As Long = 0, Optional ByVal py As Long = 0) As Boolean
    Dim UB As Integer, W As Boolean
    UB = 0
    On Error Resume Next
    UB = UBound(MonitorId)
    On Error GoTo 0
    ReDim Preserve MonitorId(UB + 1)
    MonitorId(UBound(MonitorId)) = CStr(hMonitor)
    'check whether the point (0, 0) lies within the bounds of this monitor
    W = (MonitorFromPoint(px, py, MONITOR_DEFAULTTONEAREST) = hMonitor)
    If W Then
        Debug.Print "The point (" & CStr(px) & "," & CStr(py) & ") lies within the range of this monitor..."
    End If
    MonitorEnumProc = True
End Function

Public Function SystemMetrics(ByVal uindex As SystemMetricsConstants) As Long
    SystemMetrics = GetSystemMetrics(uindex)
End Function

Public Function PointsPerPixelX() As Double
    Dim hDC As Long
    Dim lDotsPerInch As Long
    hDC = GetDC(0)
    lDotsPerInch = GetDeviceCaps(hDC, LOGPIXELSX)
    PointsPerPixelX = PointsPerInch / lDotsPerInch
    ReleaseDC 0, hDC
End Function

Public Function PointsPerPixelY() As Double
    Dim hDC As Long
    Dim lDotsPerInch As Long
    hDC = GetDC(0)
    lDotsPerInch = GetDeviceCaps(hDC, LOGPIXELSX)
    PointsPerPixelY = PointsPerInch / lDotsPerInch
    ReleaseDC 0, hDC
End Function

' Ausgeben Rechteck-Koordinaten ins Direktfenster
Public Sub debugRect(r() As Variant)
    Debug.Print (r(0) & " / " & r(1) & " / " & r(2) & " / " & r(3))
End Sub

